/* from http://www.senocular.com/flash/actionscript.php?file=ActionScript_1.0/Classes/Timer.as
Timer class, uses getTimer for timing
timerInstance = new Timer( [ startCountDown ] );
- constructor, creates timer instance.  Optional startCountDown to start timer

* Methods:
timerInstance.start();
- begins timer, if the timer is already playing (not paused) start will restart it

timerInstance.stop();
- pauses timer

timerInstance.reset( [ startCountDown ] );
- resets timer time to 0


* Properties:
timerInstance.paused;
- boolean; determines whether timer is playing (true) or not (false)

timerInstance.time;
- number; time in milliseconds the timer has been running
*/


Timer = function(start){
	this.reset(start);
}
Timer.prototype.start = function(){
	if (this._pauseTime){
		this._startTime += getTimer() - this._pauseTime;
		this._pauseTime = 0;
	}else{
		this.reset(true);
	}
}
Timer.prototype.stop = function(){
	if (!this._pauseTime) this._pauseTime = getTimer();
}
Timer.prototype.reset = function(restart){
	this._startTime = getTimer();
	if (!this._startTime) this._startTime = 1;
	if (restart) this._pauseTime = 0;
	else this._pauseTime = this._startTime;
}

Timer.prototype.getTime = function(){
	if (this._pauseTime) return this._pauseTime - this._startTime;
	var gotTime = getTimer();
	if (!gotTime) gotTime = 1;
	return gotTime - this._startTime;
}
Timer.prototype.setTime = function(t){
	this._startTime = getTimer() - t;
}
Timer.prototype.addProperty("time",Timer.prototype.getTime,Timer.prototype.setTime);

Timer.prototype.getPaused = function(){
	return (this._pauseTime) ? true : false;
}
Timer.prototype.setPaused = function(p){
	if (p == Boolean(this._pauseTime)) return false;
	if (p) this.stop();
	else this.start();
}
Timer.prototype.addProperty("paused",Timer.prototype.getPaused,Timer.prototype.setPaused);